HDU 3605 Escape(最大流+合并点)

Escape

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 10116    Accepted Submission(s): 2424


Problem Description
2012 If this is the end of the world how to do? I do not know how. But now scientists have found that some stars, who can live, but some people do not fit to live some of the planet. Now scientists want your help, is to determine what all of people can live in these planets.
 

Input
More set of test data, the beginning of each data is n (1 <= n <= 100000), m (1 <= m <= 10) n indicate there n people on the earth, m representatives m planet, planet and people labels are from 0. Here are n lines, each line represents a suitable living conditions of people, each row has m digits, the ith digits is 1, said that a person is fit to live in the ith-planet, or is 0 for this person is not suitable for living in the ith planet.
The last line has m digits, the ith digit ai indicates the ith planet can contain ai people most..
0 <= ai <= 100000
 

Output
Determine whether all people can live up to these stars
If you can output YES, otherwise output NO.
 

Sample Input

1 1 1 1 2 2 1 0 1 0 1 1
 

Sample Output

YES NO
 

Source
2010 ACM-ICPC Multi-University Training Contest(17)——Host by ZSTU 
 

Recommend
lcy


题目大意:

    有N(1=


解题思路:

    题目本身只是一道裸的二分图多重匹配,不过有一点麻烦的是N有点大,可能会导致超时,这样我们就要考虑合并点了。根据Edelweiss写的三条合并规则中的第二条,我们可以发现这些人的边只会指向10个点,那么一共只有2^10=1024种情况。所以我们就可以把相同去向相同的边合并到一起,这样就可以保证一定不会超时了。


AC代码:

#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
#include 
using namespace std;
#define INF 0x3f3f3f3f
#define LL long long
#define fi first
#define se second
#define mem(a,b) memset((a),(b),sizeof(a))

const int MAXN=1024+3;
const int MAXM=10+2;
const int MAXV=MAXN+MAXM;

struct Edge
{
    int to,cap,rev;
    Edge(int t,int c,int r):to(t),cap(c),rev(r){}
};

int N,M,V;
int cnt[1< G[MAXV];
int level[MAXV];
int iter[MAXV];

void add_edge(int from,int to,int cap)
{
    G[from].push_back(Edge(to,cap,G[to].size()));
    G[to].push_back(Edge(from,0,G[from].size()-1));
}

void bfs(int s)
{
    mem(level,-1);
    queue que;
    level[s]=0;
    que.push(s);
    while(!que.empty())
    {
        int v=que.front(); que.pop();
        for(int i=0;i0&&level[e.to]<0)
            {
                level[e.to]=level[v]+1;
                que.push(e.to);
            }
        }
    }
}

int dfs(int v,int t,int f)
{
    if(v==t)
        return f;
    for(int &i=iter[v];i0)
            {
                e.cap-=d;
                G[e.to][e.rev].cap+=d;
                return d;
            }
        }
    }
    return 0;
}

int dinic(int s,int t)
{
    int flow=0;
    for(;;)
    {
        bfs(s);
        if(level[t]<0)
            return flow;
        mem(iter,0);
        int f;
        while((f=dfs(s,t,INF))>0)
            flow+=f;
    }
}

void init()
{
    for(int i=0;i>j)&1)
                    add_edge(i,1024+j,INF);
        }
        for(int i=0;i

你可能感兴趣的:(算法,图论)